diff --git a/MAINTAINERS b/MAINTAINERS
index 88449b7a4c95..d53cd8945bb5 100644
--- a/MAINTAINERS
+++ b/MAINTAINERS
@@ -19075,7 +19075,15 @@ L:	netdev@vger.kernel.org
 S:	Maintained
 W:	https://github.com/petkan/rtl8150
 T:	git git://github.com/petkan/rtl8150.git
-F:	drivers/net/usb/rtl8150.c
+F:	drivers/net/usb/realtek/rtl8150.c
+
+USB RTL8152 DRIVER
+L:	nic_swsd@realtek.com
+L:	linux-usb@vger.kernel.org
+L:	netdev@vger.kernel.org
+S:	Maintained
+F:	drivers/net/usb/realtek/*
+X:	drivers/net/usb/realtek/rtl8150.c
 
 USB SERIAL SUBSYSTEM
 M:	Johan Hovold <johan@kernel.org>
diff --git a/drivers/net/usb/Kconfig b/drivers/net/usb/Kconfig
index 4c5d69732a7e..b15d0530c74a 100644
--- a/drivers/net/usb/Kconfig
+++ b/drivers/net/usb/Kconfig
@@ -85,27 +85,7 @@ config USB_PEGASUS
 	  To compile this driver as a module, choose M here: the
 	  module will be called pegasus.
 
-config USB_RTL8150
-	tristate "USB RTL8150 based ethernet device support"
-	select MII
-	help
-	  Say Y here if you have RTL8150 based usb-ethernet adapter.
-	  Send me <petkan@users.sourceforge.net> any comments you may have.
-	  You can also check for updates at <http://pegasus2.sourceforge.net/>.
-
-	  To compile this driver as a module, choose M here: the
-	  module will be called rtl8150.
-
-config USB_RTL8152
-	tristate "Realtek RTL8152/RTL8153 Based USB Ethernet Adapters"
-	select MII
-	help
-	  This option adds support for Realtek RTL8152 based USB 2.0
-	  10/100 Ethernet adapters and RTL8153 based USB 3.0 10/100/1000
-	  Ethernet adapters.
-
-	  To compile this driver as a module, choose M here: the
-	  module will be called r8152.
+source "drivers/net/usb/realtek/Kconfig"
 
 config USB_LAN78XX
 	tristate "Microchip LAN78XX Based USB Ethernet Adapters"
@@ -630,12 +610,4 @@ config USB_NET_AQC111
 	  This driver should work with at least the following devices:
 	  * Aquantia AQtion USB to 5GbE
 
-config USB_RTL8153_ECM
-	tristate "RTL8153 ECM support"
-	depends on USB_NET_CDCETHER && (USB_RTL8152 || USB_RTL8152=n)
-	help
-	  This option supports ECM mode for RTL8153 ethernet adapter, when
-	  CONFIG_USB_RTL8152 is not set, or the RTL8153 device is not
-	  supported by r8152 driver.
-
 endif # USB_NET_DRIVERS
diff --git a/drivers/net/usb/Makefile b/drivers/net/usb/Makefile
index 4964f7b326fb..2767d8089f25 100644
--- a/drivers/net/usb/Makefile
+++ b/drivers/net/usb/Makefile
@@ -6,8 +6,7 @@
 obj-$(CONFIG_USB_CATC)		+= catc.o
 obj-$(CONFIG_USB_KAWETH)	+= kaweth.o
 obj-$(CONFIG_USB_PEGASUS)	+= pegasus.o
-obj-$(CONFIG_USB_RTL8150)	+= rtl8150.o
-obj-$(CONFIG_USB_RTL8152)	+= r8152.o
+obj-y				+= realtek/
 obj-$(CONFIG_USB_HSO)		+= hso.o
 obj-$(CONFIG_USB_LAN78XX)	+= lan78xx.o
 obj-$(CONFIG_USB_NET_AX8817X)	+= asix.o
@@ -41,4 +40,3 @@ obj-$(CONFIG_USB_NET_QMI_WWAN)	+= qmi_wwan.o
 obj-$(CONFIG_USB_NET_CDC_MBIM)	+= cdc_mbim.o
 obj-$(CONFIG_USB_NET_CH9200)	+= ch9200.o
 obj-$(CONFIG_USB_NET_AQC111)	+= aqc111.o
-obj-$(CONFIG_USB_RTL8153_ECM)	+= r8153_ecm.o
diff --git a/drivers/net/usb/realtek/Kconfig b/drivers/net/usb/realtek/Kconfig
new file mode 100644
index 000000000000..1afa85480b8f
--- /dev/null
+++ b/drivers/net/usb/realtek/Kconfig
@@ -0,0 +1,33 @@
+# SPDX-License-Identifier: GPL-2.0-only
+#
+# Reatlek USB Network devices configuration
+#
+config USB_RTL8150
+	tristate "USB RTL8150 based ethernet device support"
+	select MII
+	help
+	  Say Y here if you have RTL8150 based usb-ethernet adapter.
+	  Send me <petkan@users.sourceforge.net> any comments you may have.
+	  You can also check for updates at <http://pegasus2.sourceforge.net/>.
+
+	  To compile this driver as a module, choose M here: the
+	  module will be called rtl8150.
+
+config USB_RTL8152
+	tristate "Realtek RTL8152/RTL8153 Based USB Ethernet Adapters"
+	select MII
+	help
+	  This option adds support for Realtek RTL8152 based USB 2.0
+	  10/100 Ethernet adapters and RTL8153 based USB 3.0 10/100/1000
+	  Ethernet adapters.
+
+	  To compile this driver as a module, choose M here: the
+	  module will be called r8152.
+
+config USB_RTL8153_ECM
+	tristate "RTL8153 ECM support"
+	depends on USB_NET_CDCETHER && (USB_RTL8152 || USB_RTL8152=n)
+	help
+	  This option supports ECM mode for RTL8153 ethernet adapter, when
+	  CONFIG_USB_RTL8152 is not set, or the RTL8153 device is not
+	  supported by r8152 driver.
diff --git a/drivers/net/usb/realtek/Makefile b/drivers/net/usb/realtek/Makefile
new file mode 100644
index 000000000000..6f89910a8f76
--- /dev/null
+++ b/drivers/net/usb/realtek/Makefile
@@ -0,0 +1,8 @@
+# SPDX-License-Identifier: GPL-2.0-only
+#
+# Makefile for the Realtek USB network device drivers.
+#
+
+obj-$(CONFIG_USB_RTL8150)	+= rtl8150.o
+obj-$(CONFIG_USB_RTL8152)	+= r8152.o
+obj-$(CONFIG_USB_RTL8153_ECM)	+= r8153_ecm.o
diff --git a/drivers/net/usb/r8152.c b/drivers/net/usb/realtek/r8152.c
similarity index 100%
rename from drivers/net/usb/r8152.c
rename to drivers/net/usb/realtek/r8152.c
diff --git a/drivers/net/usb/r8153_ecm.c b/drivers/net/usb/realtek/r8153_ecm.c
similarity index 100%
rename from drivers/net/usb/r8153_ecm.c
rename to drivers/net/usb/realtek/r8153_ecm.c
diff --git a/drivers/net/usb/rtl8150.c b/drivers/net/usb/realtek/rtl8150.c
similarity index 100%
rename from drivers/net/usb/rtl8150.c
rename to drivers/net/usb/realtek/rtl8150.c